#include "dll.h"

extern "C"
{
   __declspec(dllexport) int Median(int dim, int dim_x, int dim_y, double* a, double* b)
   {
       //--------------------------------------------------------------------------------
       //   This function calculates the median image from a serie of images
       //   Calculation is performed pixel by pixel
       //--------------------------------------------------------------------------------
       //dim = number of images
       //dim_x = number of pixels in x (vertical) direction on individual images
       //dim_y = number of pixels in y (horizontal) direction on individual images
       //a = serie of input images (single 1D array)
       //b = median image (single 1D array)
       double *buffer = new double[dim];

        for (int i=0; i<dim_x; i++)
        for (int j=0; j<dim_y; j++)
        {
            for (int p=0; p<dim; p++)
                buffer[p] = a[p*dim_x*dim_y + i*dim_y + j];

            b[i*dim_y + j] = median(buffer,dim);
        }

      return(0);
   }
   __declspec(dllexport) int Median2(int dim, int dim_x, int dim_y, double* a, double* b)
   {
       //--------------------------------------------------------------------------------
       //   This function calculates the median pixel on each image from a serie of images
       //   Calculation is performed image by image
       //--------------------------------------------------------------------------------
       //dim = number of images
       //dim_x = number of pixels in x (vertical) direction on individual images
       //dim_y = number of pixels in y (horizontal) direction on individual images
       //a = serie of input images (single 1D array)
       //b = output median values per images (single 1D array)
       double *buffer = new double[dim_x*dim_y];

        for (int p=0; p<dim; p++)
        {
            for (int i=0; i<dim_x; i++)
            for (int j=0; j<dim_y; j++)
                    buffer[i*dim_y + j] = a[p*dim_x*dim_y + i*dim_y + j];

            b[p] = median(buffer,dim_x*dim_y);
        }
      return(0);
   }
}

