# -*- coding: iso_8859_1 -*-

import astro
import numpy as np

#------ input parameters ------
Folder = u"C:\\Documents and Settings\\Jrme\\Bureau\\29mar2011\\processing\\Chryseis\\"
Imagelist = ["Chryseis-calibrated-" + str(i+1) + ".fit" for i in range(304)]
Imagelist2 = ["Chryseis-filtered2-" + str(i+1) + ".fit" for i in range(304)]

image = astro.getdata(Folder, [Imagelist[0]])
filter = image*0.
filter[1,1]=0.25
filter[1,0]=0.5
filter[1,-1]=0.25
filter[0,1]=0.5
filter[0,0]=1.
filter[0,-1]=0.5
filter[-1,1]=0.25
filter[-1,0]=0.5
filter[-1,-1]=0.25
filter = filter / np.sum(filter.flatten())
im2 = np.fft.fft2(filter)

#------ loads data and headers ------
for i in range(len(Imagelist)):
	image = astro.getdata(Folder, [Imagelist[i]])
	headers = astro.getheaders(Folder, [Imagelist[i]])

	im1 = np.fft.fft2(image)
	image = np.abs(np.fft.ifft2(im1*np.ma.conjugate(im2)))

	#------ save (eventually modified) image list under new name ------
	#astro.save_fits(images, headers, Folder, Imagelist2)
	astro.save_fits(image, [headers[0]], Folder, [Imagelist2[i]])

raw_input()